CaseTecnicoWeb/Controllers/ColheitaController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using AutoMapper;
using CaseTecnicoWeb.Models.DataTransferObjects;
using CaseTecnicoWeb.Models.ViewModels;
using CaseTecnicoWeb.Service.Spec;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;

namespace CaseTecnicoWeb.Controllers
{
    public class ColheitaController : Controller
    {

        private readonly IColheitaService _colheitaService;
        private readonly IArvoresService _arvoresService;
        IMapper _mapper;

        public ColheitaController(IColheitaService colheitaService, IMapper mapper, IArvoresService arvoresService)
        {
            _colheitaService = colheitaService;
            _mapper = mapper;
            _arvoresService = arvoresService;
        }

        // GET: ColheitaController
        public ActionResult Index()
        {
            ViewBag.Arvores = _mapper.Map<List<ArvoresViewModel>>(_arvoresService.GetAll());
            var retorno = _mapper.Map<List<ColheitaViewModel>>(_colheitaService.GetAll());
            return View(retorno);
        }
        public ActionResult Filtrar(int arvore, DateTime de, DateTime ate)
        {
            ViewBag.Arvores = _mapper.Map<List<ArvoresViewModel>>(_arvoresService.GetAll());
            var retorno = _mapper.Map<List<ColheitaViewModel>>(_colheitaService.GetAll());
            if (arvore != 0)
            {
                retorno = retorno.Where(x => x.ArvoresId == arvore).ToList();
            }
            retorno = retorno.Where(x => x.DataDaColheita.Date >= de.Date && x.DataDaColheita.Date <= ate.Date).ToList();
            return View("Index", retorno);
        }
        // GET: ColheitaController/Details/5
        public ActionResult Details(int id)
        {
            var retorno = _mapper.Map<ColheitaViewModel>(_colheitaService.GetById(id));
            return View(retorno);
        }

        // GET: ColheitaController/Create
        public ActionResult Create()
        {
            ViewBag.Arvores = _mapper.Map<List<ArvoresViewModel>>(_arvoresService.GetAll());
            return View(new ColheitaViewModel() { });
        }

        // POST: ColheitaController/Create
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Create(ColheitaViewModel model)
        {
            try
            {

                if (string.IsNullOrEmpty(model.Informacoes) || model.PesoBruto <= 0 || model.ArvoresId <= 0)
                {

                    ViewBag.Arvores = _mapper.Map<List<ArvoresViewModel>>(_arvoresService.GetAll());
                    var retornoModel = _mapper.Map<List<ColheitaViewModel>>(_colheitaService.GetAll());
                    ViewBag.Error = "Preencha os campos corretamente para pode realizar a requisição";
                    return View("Index",retornoModel);
                }
                var retorno = _colheitaService.Insert(_mapper.Map<DTOColheita>(model));
                return RedirectToAction(nameof(Index));
            }
            catch
            {
                return View();
            }
        }

        // GET: ColheitaController/Edit/5
        public ActionResult Edit(int id)
        {
            ViewBag.Arvores = _mapper.Map<List<ArvoresViewModel>>(_arvoresService.GetAll());
            var retorno = _mapper.Map<ColheitaViewModel>(_colheitaService.GetById(id));
            return View(retorno);
        }

        // POST: ColheitaController/Edit/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Edit(int id, ColheitaViewModel model)
        {
            try
            {
                if (string.IsNullOrEmpty(model.Informacoes) || model.PesoBruto <= 0 || model.ArvoresId <= 0)
                {

                    ViewBag.Arvores = _mapper.Map<List<ArvoresViewModel>>(_arvoresService.GetAll());
                    ViewBag.Error = "Preencha os campos corretamente para pode realizar a requisição";
                    return View(model);
                }
                var retorno = _colheitaService.Edit(id, _mapper.Map<DTOColheita>(model));
                return RedirectToAction(nameof(Index));
            }
            catch
            {
                return View();
            }
        }

        // GET: ColheitaController/Delete/5
        public ActionResult Delete(int id)
        {
            var retorno = _mapper.Map<ColheitaViewModel>(_colheitaService.GetById(id));
            return View(retorno);
        }

        // POST: ColheitaController/Delete/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Delete(int id, ColheitaViewModel model)
        {
            try
            {
                var retorno = _colheitaService.Delete(id);
                return RedirectToAction(nameof(Index));
            }
            catch
            {
                return View();
            }
        }
    }
}

CaseTecnicoWeb/Views/Colheita/Create.cshtml
@model CaseTecnicoWeb.Models.ViewModels.ColheitaViewModel

@{
    ViewData["Title"] = "Cadastrar nova colheita";
}

<h1>Cadastrar</h1>

<h4>Cadsatrar nova colheita</h4>
<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="Create">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <div class="form-group">
                <label asp-for="Informacoes" class="control-label"></label>
                <input asp-for="Informacoes" class="form-control" />
                <span asp-validation-for="Informacoes" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="DataDaColheita" class="control-label"></label>
                <input asp-for="DataDaColheita" class="form-control" />
                <span asp-validation-for="DataDaColheita" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="PesoBruto" class="control-label"></label>
                <input asp-for="PesoBruto" class="form-control" />
                <span asp-validation-for="PesoBruto" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="ArvoresId" class="control-label"></label>
                @Html.DropDownList("ArvoresId", new SelectList(ViewBag.Arvores, "ArvoresId", "Descricao"), new { @class = "form-control" })
                <span asp-validation-for="ArvoresId" class="text-danger"></span>
            </div>
            <div class="form-group">
                <input type="submit" value="Cadastrar" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-action="Index">Voltar para lista</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}

CaseTecnicoWeb/Views/Colheita/Delete.cshtml
@model CaseTecnicoWeb.Models.ViewModels.ColheitaViewModel

@{
    ViewData["Title"] = "Deletar colheita";
}

<h1>Deletar</h1>

<h3>Você tem certeza que quer deletar este item ?</h3>
<h4 class="text-warning"><b>ATENÇÃO: Todos os itens vinculados à ele também serão deletados.</b></h4>
<div>
    <h4>Deletar colheita</h4>
    <hr />
    <dl class="row">
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.ColheitaId)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.ColheitaId)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Informacoes)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Informacoes)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.DataDaColheita)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.DataDaColheita)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.PesoBruto)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.PesoBruto)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Arvores.Descricao)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Arvores.Descricao)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Arvores.Idade)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Arvores.Idade)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Arvores.Especies.Descricao)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Arvores.Especies.Descricao)
        </dd>
    </dl>

    <form asp-action="Delete">
        <input type="submit" value="Deletar" class="btn btn-danger" /> |
        <a asp-action="Index">Voltar para lista</a>
    </form>
</div>

CaseTecnicoWeb/Views/Colheita/Details.cshtml
@model CaseTecnicoWeb.Models.ViewModels.ColheitaViewModel

@{
    ViewData["Title"] = "DEtalhar colheita";
}

<h1>Detalhar colheita</h1>

<div>
    <hr />
    <dl class="row">
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.ColheitaId)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.ColheitaId)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Informacoes)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Informacoes)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.DataDaColheita)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.DataDaColheita)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.PesoBruto)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.PesoBruto)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Arvores.Descricao)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Arvores.Descricao)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Arvores.Idade)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Arvores.Idade)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Arvores.Especies.Descricao)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Arvores.Especies.Descricao)
        </dd>
    </dl>
</div>
<div>
    @Html.ActionLink("Editar", "Edit", new { id = Model.ColheitaId }) |
    <a asp-action="Index">Voltar para lista</a>
</div>

CaseTecnicoWeb/Views/Colheita/Edit.cshtml
@model CaseTecnicoWeb.Models.ViewModels.ColheitaViewModel

@{
    ViewData["Title"] = "Editar Colheita";
}

<h1>Editar</h1>

<h4>Editar colheita</h4>
<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="Edit">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <div class="form-group">
                <label asp-for="ColheitaId" class="control-label"></label>
                <input asp-for="ColheitaId" disabled class="form-control" />
                <span asp-validation-for="ColheitaId" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Informacoes" class="control-label"></label>
                <input asp-for="Informacoes" class="form-control" />
                <span asp-validation-for="Informacoes" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="DataDaColheita" class="control-label"></label>
                <input asp-for="DataDaColheita" class="form-control" />
                <span asp-validation-for="DataDaColheita" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="PesoBruto" class="control-label"></label>
                <input asp-for="PesoBruto" class="form-control" />
                <span asp-validation-for="PesoBruto" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="ArvoresId" class="control-label"></label>
                @Html.DropDownList("ArvoresId", new SelectList(ViewBag.Arvores, "ArvoresId", "Descricao"), new { @class = "form-control" })
                <span asp-validation-for="ArvoresId" class="text-danger"></span>
            </div>
            <div class="form-group">
                <input type="submit" value="Salvar" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-action="Index">Voltar para lista</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}

CaseTecnicoWeb/Views/Colheita/Index.cshtml
@model IEnumerable<CaseTecnicoWeb.Models.ViewModels.ColheitaViewModel>

@{
    ViewData["Title"] = "Listagem de colheitas";
}

<h1>Listagem de colheitas</h1>

<p>
    <a asp-action="Create">Cadastrar nova colheita</a>
</p>

@using (Html.BeginForm("Filtrar", "Colheita", FormMethod.Post))
{
    <div style="text-align: -webkit-center; background-color: #ececec; border-radius: 7px;">

        <div class="form-group col-md-12">
            <br />
            <div class="row">
                <div class="col-md-4">
                    <div class="col-md-12">
                        <label class="form-label" for="tipoConta">Arvore</label>
                        <br />
                        <select class="form-control  form-control-sm" name="arvore" id="arvore">
                            <option selected disabled value="0">*SELECIONE*</option>
                            @foreach (var item in ViewBag.Arvores)
                            {
                                <option value="@item.ArvoresId">@item.Descricao</option>
                            }
                        </select>
                    </div>
                </div>
                <div class="col-md-4">
                    <div class="col-md-12">
                        <label class="form-label" for="tipoConta">De</label>
                        <br />
                        <input min="2019-01-01" value="2019-01-01" type="date" class="form-control form-control-sm" name="de" id="de" />
                    </div>
                </div>
                <div class="col-md-4">
                    <div class="col-md-12">
                        <label class="form-label" for="tipoConta">Até</label>
                        <br />
                        <input type="date" min="2019-01-01" class="form-control form-control-sm" name="ate" id="ate" />
                    </div>
                </div>
            </div>
            <br />
            <div class="row">
                <div class="col-md-12 ">
                    <input type="submit" value="Filtrar" class="btn btn-sm btn-primary float-right" />
                </div>
            </div>
            <br />
        </div>
    </div>
}
<table class="table">
    <thead>
        <tr>
            <th>
                @Html.DisplayNameFor(model => model.ColheitaId)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.Informacoes)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.DataDaColheita)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.PesoBruto)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.ArvoresId)
            </th>
            <th></th>
        </tr>
    </thead>
    <tbody>
        @foreach (var item in Model)
        {
            <tr>
                <td>
                    @Html.DisplayFor(modelItem => item.ColheitaId)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.Informacoes)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.DataDaColheita)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.PesoBruto)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.Arvores.Descricao)
                </td>
                <td>
                    @Html.ActionLink("Editar", "Edit", new { id = item.ColheitaId }) |
                    @Html.ActionLink("Detalhar", "Details", new { id = item.ColheitaId }) |
                    @Html.ActionLink("Deletar", "Delete", new { id = item.ColheitaId })
                </td>
            </tr>
        }
    </tbody>
</table>
<script>
    $(document).ready(function () {

        var today = new Date();
        var dd = today.getDate();
        var mm = today.getMonth() + 1; //January is 0!
        var yyyy = today.getFullYear();
        if (dd < 10) {
            dd = '0' + dd
        }
        if (mm < 10) {
            mm = '0' + mm
        }

        today = yyyy + '-' + mm + '-' + dd;
        document.getElementById("de").setAttribute("max", today);
        document.getElementById("ate").setAttribute("max", today);
        document.getElementById("ate").setAttribute("value", today);
    });
</script>